<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: Charset</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>Charset<br/>
<small>
[<a class="el" href="group__m17nShell.html">SHELL API</a>]</small>
</h1>
<p>Charset objects and API for them.  
<a href="#_details">More...</a></p>
<table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Defines</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">#define&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaed3feae2f280e7413725a5090175591a">MCHAR_INVALID_CODE</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Invalid code-point.  <a href="#gaed3feae2f280e7413725a5090175591a"></a><br/></td></tr>
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaadbf43a8bb53d9056dd10a64e8424e30">mchar_define_charset</a> (const char *name, <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *plist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Define a charset.  <a href="#gaadbf43a8bb53d9056dd10a64e8424e30"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaf8f077d7d45aaf0a68a3b638c24043fc">mchar_resolve_charset</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> symbol)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Resolve charset name.  <a href="#gaf8f077d7d45aaf0a68a3b638c24043fc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga9ffc490ec2ef0fb0509f09d161de6b85">mchar_list_charset</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> **symbols)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">List symbols representing charsets.  <a href="#ga9ffc490ec2ef0fb0509f09d161de6b85"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gac1a030a59290d16200818056943e93cd">mchar_decode</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> charset_name, unsigned code)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Decode a code-point.  <a href="#gac1a030a59290d16200818056943e93cd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gae199b17a440f6e1d669e60a77df87e6a">mchar_encode</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> charset_name, int c)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Encode a character code.  <a href="#gae199b17a440f6e1d669e60a77df87e6a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gad218c3916b17c1f42769e2316a6aa557">mchar_map_charset</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> charset_name, void(*func)(int from, int to, void *arg), void *func_arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Call a function for all the characters in a specified charset.  <a href="#gad218c3916b17c1f42769e2316a6aa557"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga45426542709f174689a06ce7c34a37de">Mcharset</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The symbol <code>Mcharset</code>.  <a href="#ga45426542709f174689a06ce7c34a37de"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables: Symbols representing a charset.</h2></td></tr>
<tr><td colspan="2"><p><a class="anchor" id="amgrpbf9cb86107f068f5f442060d6633757d"></a> Each of the following symbols represents a predefined charset. </p>
<br/><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga01281aed6d1604db0c98ac17c64b22e3">Mcharset_ascii</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol representing the charset ASCII.  <a href="#ga01281aed6d1604db0c98ac17c64b22e3"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga9f7fa705b5a9329979b6f7dba5b33fef">Mcharset_iso_8859_1</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol representing the charset ISO/IEC 8859/1.  <a href="#ga9f7fa705b5a9329979b6f7dba5b33fef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga9a9826645fbd6d8cbc8dade0a05d93ca">Mcharset_unicode</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol representing the charset Unicode.  <a href="#ga9a9826645fbd6d8cbc8dade0a05d93ca"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gae9d2842894a69850db2bfba1e7003938">Mcharset_m17n</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol representing the largest charset.  <a href="#gae9d2842894a69850db2bfba1e7003938"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaada84095266aedae3aed95ae942c47a0">Mcharset_binary</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol representing the charset for ill-decoded characters.  <a href="#gaada84095266aedae3aed95ae942c47a0"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables: Parameter keys for mchar_define_charset().</h2></td></tr>
<tr><td colspan="2"><p><a class="anchor" id="amgrpb7a744e806b758095ef2caff42c23d3a"></a> These are the predefined symbols to use as parameter keys for the function <a class="el" href="group__m17nCharset.html#gaadbf43a8bb53d9056dd10a64e8424e30" title="Define a charset.">mchar_define_charset()</a> (which see). </p>
<br/><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gae4f12e8c6f7383fc7c05388185ad7795">Mmethod</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga26a7745dfcd4b7e75ba08b006a94205b">Mdimension</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga290793cbf5b9e6aa96cce8e12e01af29">Mmin_range</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gad01176e5eeb7ee45fc3b144aa0393ccd">Mmax_range</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga002a4010b574d5b09e33281634c2b058">Mmin_code</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga71d715404e85831b2be9c1bb4044d1c7">Mmax_code</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga7c88134db9c464946410a44ae32969c5">Mascii_compatible</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga6fe1a313c304442d884f1dcefad262f0">Mfinal_byte</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaa971af170d28beb8e9ffca53e03f2233">Mrevision</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gac519cab6fd5381b289b54f9bc3f5614f">Mmin_char</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gac7f334207f0907557e1805f327be2c0a">Mmapfile</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gab8f3c2a0d58caa179931151fa64e5eb0">Mparents</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gafcc44fe2009682c71b47f6157f07b85c">Msubset_offset</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gad98a8b772b9e851ae2920c5d7ed7c706">Mdefine_coding</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga150e01319257d2b8e82952baf4fbb16d">Maliases</a></td></tr>
<tr><td colspan="2"><h2>Variables: Symbols representing charset methods.</h2></td></tr>
<tr><td colspan="2"><p><a class="anchor" id="amgrpbfc9a715ae60879fd985e8198b49a958"></a> These are the predefined symbols that can be a value of the <b>Mmethod</b> parameter of a charset used in an argument to the <a class="el" href="group__m17nCharset.html#gaadbf43a8bb53d9056dd10a64e8424e30" title="Define a charset.">mchar_define_charset()</a> function.</p>
<p>A method specifies how code-points and character codes are converted. See the documentation of the <a class="el" href="group__m17nCharset.html#gaadbf43a8bb53d9056dd10a64e8424e30" title="Define a charset.">mchar_define_charset()</a> function for the details. </p>
<br/><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#ga7a86139a02caa1fba4cc46985b76c71b">Moffset</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for the offset type method of charset.  <a href="#ga7a86139a02caa1fba4cc46985b76c71b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaa774b1759de6142d26ffe8d5898c3874">Mmap</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for the map type method of charset.  <a href="#gaa774b1759de6142d26ffe8d5898c3874"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gadd42d3be420b71333a771b05e4e5b6eb">Munify</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for the unify type method of charset.  <a href="#gadd42d3be420b71333a771b05e4e5b6eb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gaf9a6baf718f22984b5c5332afff0da90">Msubset</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for the subset type method of charset.  <a href="#gaf9a6baf718f22984b5c5332afff0da90"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nCharset.html#gadb08660f5913095d985cfbbd1a51b0bb">Msuperset</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol for the superset type method of charset.  <a href="#gadb08660f5913095d985cfbbd1a51b0bb"></a><br/></td></tr>
</table>
<hr/><a name="_details"></a><h2>Detailed Description</h2>
<p>Charset objects and API for them. </p>
<p>The m17n library uses <em>charset</em> objects to represent a coded character sets (CCS). The m17n library supports many predefined coded character sets. Moreover, application programs can add other charsets. A character can belong to multiple charsets.</p>
<p>The m17n library distinguishes the following three concepts:</p>
<ul>
<li>A <em>code-point</em> is a number assigned by the CCS to each character. Code-points may or may not be continuous. The type <code>unsigned</code> is used to represent a code-point. An invalid code-point is represented by the macro <code>MCHAR_INVALID_CODE</code>.</li>
</ul>
<ul>
<li>A <em>character</em> <em>index</em> is the canonical index of a character in a CCS. The character that has the character index N occupies the Nth position when all the characters in the current CCS are sorted by their code-points. Character indices in a CCS are continuous and start with 0.</li>
</ul>
<ul>
<li>A <em>character</em> <em>code</em> is the internal representation in the m17n library of a character. A character code is a signed integer of 21 bits or longer.</li>
</ul>
<p>Each charset object defines how characters are converted between code-points and character codes. To <em>encode</em> means converting code-points to character codes and to <em>decode</em> means converting character codes to code-points. </p>
<hr/><h2>Define Documentation</h2>
<a class="anchor" id="gaed3feae2f280e7413725a5090175591a"></a><!-- doxytag: member="charset.c::MCHAR_INVALID_CODE" ref="gaed3feae2f280e7413725a5090175591a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">#define MCHAR_INVALID_CODE</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Invalid code-point. </p>
<p>The macro <a class="el" href="group__m17nCharset.html#gaed3feae2f280e7413725a5090175591a" title="Invalid code-point.">MCHAR_INVALID_CODE</a> gives the invalid code-point. </p>

</div>
</div>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="gaadbf43a8bb53d9056dd10a64e8424e30"></a><!-- doxytag: member="charset.c::mchar_define_charset" ref="gaadbf43a8bb53d9056dd10a64e8424e30" args="(const char *name, MPlist *plist)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mchar_define_charset </td>
          <td>(</td>
          <td class="paramtype">const char *&nbsp;</td>
          <td class="paramname"> <em>name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td>
          <td class="paramname"> <em>plist</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Define a charset. </p>
<p>The <a class="el" href="group__m17nCharset.html#gaadbf43a8bb53d9056dd10a64e8424e30" title="Define a charset.">mchar_define_charset()</a> function defines a new charset and makes it accessible via a symbol whose name is <b>name</b>. <b>plist</b> specifies parameters of the charset as below:</p>
<ul>
<li>
<p class="startli">Key is <b>Mmethod</b>, value is a symbol.</p>
<p>The value specifies the method for decoding/encoding code-points in the charset. It must be <a class="el" href="group__m17nCharset.html#ga7a86139a02caa1fba4cc46985b76c71b" title="Symbol for the offset type method of charset.">Moffset</a>, <a class="el" href="group__m17nCharset.html#gaa774b1759de6142d26ffe8d5898c3874" title="Symbol for the map type method of charset.">Mmap</a> (default), <a class="el" href="group__m17nCharset.html#gadd42d3be420b71333a771b05e4e5b6eb" title="Symbol for the unify type method of charset.">Munify</a>, <a class="el" href="group__m17nCharset.html#gaf9a6baf718f22984b5c5332afff0da90" title="Symbol for the subset type method of charset.">Msubset</a>, or <a class="el" href="group__m17nCharset.html#gadb08660f5913095d985cfbbd1a51b0bb" title="Symbol for the superset type method of charset.">Msuperset</a>.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mdimension</b>, value is an integer</p>
<p>The value specifies the dimension of code-points of the charset. It must be 1 (default), 2, 3, or 4.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mmin_range</b>, value is an unsigned integer</p>
<p>The value specifies the minimum range of a code-point, which means that the Nth byte of the value is the minimum Nth byte of code-points of the charset. The default value is 0.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mmax_range</b>, value is an unsigned integer</p>
<p>The value specifies the maximum range of a code-point, which means that the Nth byte of the value is the maximum Nth byte of code-points of the charset. The default value is 0xFF, 0xFFFF, 0xFFFFFF, or 0xFFFFFFFF if the dimension is 1, 2, 3, or 4 respectively.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mmin_code</b>, value is an unsigned integer</p>
<p>The value specifies the minimum code-point of the charset. The default value is the minimum range.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mmax_code</b>, value is an unsigned integer</p>
<p>The value specifies the maximum code-point of the charset. The default value is the maximum range.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mascii_compatible</b>, value is a symbol</p>
<p>The value specifies whether the charset is ASCII compatible or not. If the value is <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a> (default), it is not ASCII compatible, else compatible.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mfinal_byte</b>, value is an integer</p>
<p>The value specifies the <em>final</em> <em>byte</em> of the charset registered in The International Registry. It must be 0 (default) or 32..127. The value 0 means that the charset is not in the registry.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mrevision</b>, value is an integer</p>
<p>The value specifies the <em>revision</em> <em>number</em> of the charset registered in The International Registry. It must be 0..127. If the charset is not in The International Registry, the value is ignored. The value 0 means that the charset has no revision number.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mmin_char</b>, value is an integer</p>
<p>The value specifies the minimum character code of the charset. The default value is 0.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mmapfile</b>, value is an M-text</p>
<p>If the method is <a class="el" href="group__m17nCharset.html#gaa774b1759de6142d26ffe8d5898c3874" title="Symbol for the map type method of charset.">Mmap</a> or <a class="el" href="group__m17nCharset.html#gadd42d3be420b71333a771b05e4e5b6eb" title="Symbol for the unify type method of charset.">Munify</a>, a data that contains mapping information is added to the m17n database by calling the function <a class="el" href="group__m17nDatabase.html#ga265cfa2587dfda9bdc84f7afd1aabb1d" title="Define a data of the m17n database.">mdatabase_define()</a> with the value as an argument <b>extra_info</b>, i.e. the value is used as a file name of the data.</p>
<p>Otherwise, this parameter is ignored.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mparents</b>, value is a plist</p>
<p>If the method is <a class="el" href="group__m17nCharset.html#gaf9a6baf718f22984b5c5332afff0da90" title="Symbol for the subset type method of charset.">Msubset</a>, the value must is a plist of length 1, and the value of the plist must be a symbol representing a parent charset.</p>
<p>If the method is <a class="el" href="group__m17nCharset.html#gadb08660f5913095d985cfbbd1a51b0bb" title="Symbol for the superset type method of charset.">Msuperset</a>, the value must be a plist of length less than 9, and the values of the plist must be symbols representing subset charsets.</p>
<p>Otherwise, this parameter is ignored.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Key is <b>Mdefine_coding</b>, value is a symbol</p>
<p>If the dimension of the charset is 1, the value specifies whether or not to define a coding system of the same name whose type is <a class="el" href="group__m17nCharset.html#ga45426542709f174689a06ce7c34a37de" title="The symbol Mcharset.">Mcharset</a>. A coding system is defined if the value is not <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>.</p>
<p>Otherwise, this parameter is ignored.</p>
<p class="endli"></p>
</li>
</ul>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, <a class="el" href="group__m17nCharset.html#gaadbf43a8bb53d9056dd10a64e8424e30" title="Define a charset.">mchar_define_charset()</a> returns a symbol whose name is <b>name</b>. Otherwise it returns <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a> and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_CHARSET</code> </dd></dl>

</div>
</div>
<a class="anchor" id="gaf8f077d7d45aaf0a68a3b638c24043fc"></a><!-- doxytag: member="charset.c::mchar_resolve_charset" ref="gaf8f077d7d45aaf0a68a3b638c24043fc" args="(MSymbol symbol)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> mchar_resolve_charset </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>symbol</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Resolve charset name. </p>
<p>The <a class="el" href="group__m17nCharset.html#gaf8f077d7d45aaf0a68a3b638c24043fc" title="Resolve charset name.">mchar_resolve_charset()</a> function returns <b>symbol</b> if it represents a charset. Otherwise, canonicalize <b>symbol</b> as to a charset name, and if the canonicalized name represents a charset, return it. Otherwise, return <a class="el" href="group__m17nSymbol.html#ga0346fc05efcccc8f11271b51c0fe3eeb" title="Symbol whose name is &quot;nil&quot;.">Mnil</a>. </p>

</div>
</div>
<a class="anchor" id="ga9ffc490ec2ef0fb0509f09d161de6b85"></a><!-- doxytag: member="charset.c::mchar_list_charset" ref="ga9ffc490ec2ef0fb0509f09d161de6b85" args="(MSymbol **symbols)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchar_list_charset </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> **&nbsp;</td>
          <td class="paramname"> <em>symbols</em></td>
          <td>&nbsp;)&nbsp;</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>List symbols representing charsets. </p>
<p>The mchar_list_charsets() function makes an array of symbols representing a charset, stores the pointer to the array in a place pointed to by <b>symbols</b>, and returns the length of the array. </p>

</div>
</div>
<a class="anchor" id="gac1a030a59290d16200818056943e93cd"></a><!-- doxytag: member="charset.c::mchar_decode" ref="gac1a030a59290d16200818056943e93cd" args="(MSymbol charset_name, unsigned code)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchar_decode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>charset_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned&nbsp;</td>
          <td class="paramname"> <em>code</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Decode a code-point. </p>
<p>The <a class="el" href="group__m17nCharset.html#gac1a030a59290d16200818056943e93cd" title="Decode a code-point.">mchar_decode()</a> function decodes code-point <b>code</b> in the charset represented by the symbol <b>charset_name</b> to get a character code.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If decoding was successful, <a class="el" href="group__m17nCharset.html#gac1a030a59290d16200818056943e93cd" title="Decode a code-point.">mchar_decode()</a> returns the decoded character code. Otherwise it returns -1.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nCharset.html#gae199b17a440f6e1d669e60a77df87e6a" title="Encode a character code.">mchar_encode()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gae199b17a440f6e1d669e60a77df87e6a"></a><!-- doxytag: member="charset.c::mchar_encode" ref="gae199b17a440f6e1d669e60a77df87e6a" args="(MSymbol charset_name, int c)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned mchar_encode </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>charset_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&nbsp;</td>
          <td class="paramname"> <em>c</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Encode a character code. </p>
<p>The <a class="el" href="group__m17nCharset.html#gae199b17a440f6e1d669e60a77df87e6a" title="Encode a character code.">mchar_encode()</a> function encodes character code <b>c</b> to get a code-point in the charset represented by the symbol <b>charset_name</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If encoding was successful, <a class="el" href="group__m17nCharset.html#gae199b17a440f6e1d669e60a77df87e6a" title="Encode a character code.">mchar_encode()</a> returns the encoded code-point. Otherwise it returns <a class="el" href="group__m17nCharset.html#gaed3feae2f280e7413725a5090175591a" title="Invalid code-point.">MCHAR_INVALID_CODE</a>.</dd></dl>
<dl class="user"><dt><b>See Also:</b></dt><dd><a class="el" href="group__m17nCharset.html#gac1a030a59290d16200818056943e93cd" title="Decode a code-point.">mchar_decode()</a> </dd></dl>

</div>
</div>
<a class="anchor" id="gad218c3916b17c1f42769e2316a6aa557"></a><!-- doxytag: member="charset.c::mchar_map_charset" ref="gad218c3916b17c1f42769e2316a6aa557" args="(MSymbol charset_name, void(*func)(int from, int to, void *arg), void *func_arg)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int mchar_map_charset </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td>
          <td class="paramname"> <em>charset_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void(*)(int from, int to, void *arg)&nbsp;</td>
          <td class="paramname"> <em>func</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&nbsp;</td>
          <td class="paramname"> <em>func_arg</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Call a function for all the characters in a specified charset. </p>
<p>The mcharset_map_chars() function calls <b>func</b> for all the characters in the charset named <b>charset_name</b>. A call is done for a chunk of consecutive characters rather than character by character.</p>
<p><b>func</b> receives three arguments: <b>from</b>, <b>to</b>, and <b>arg</b>. <b>from</b> and <b>to</b> specify the range of character codes in <b>charset</b>. <b>arg</b> is the same as <b>func_arg</b>.</p>
<dl class="user"><dt><b>Return value:</b></dt><dd>If the operation was successful, mcharset_map_chars() returns 0. Otherwise, it returns -1 and assigns an error code to the external variable <a class="el" href="group__m17nError.html#ga995a2e373cfd6a8e5eaca8686b5b0a73" title="External variable to hold error code of the m17n library.">merror_code</a>.</dd></dl>
<dl class="user"><dt><b>Errors:</b></dt><dd><code>MERROR_CHARSET</code> </dd></dl>

</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="ga01281aed6d1604db0c98ac17c64b22e3"></a><!-- doxytag: member="charset.c::Mcharset_ascii" ref="ga01281aed6d1604db0c98ac17c64b22e3" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga01281aed6d1604db0c98ac17c64b22e3">Mcharset_ascii</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol representing the charset ASCII. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#ga01281aed6d1604db0c98ac17c64b22e3" title="Symbol representing the charset ASCII.">Mcharset_ascii</a> has name <code>"ascii"</code> and represents the charset ISO 646, USA Version X3.4-1968 (ISO-IR-6). </p>

</div>
</div>
<a class="anchor" id="ga9f7fa705b5a9329979b6f7dba5b33fef"></a><!-- doxytag: member="charset.c::Mcharset_iso_8859_1" ref="ga9f7fa705b5a9329979b6f7dba5b33fef" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga9f7fa705b5a9329979b6f7dba5b33fef">Mcharset_iso_8859_1</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol representing the charset ISO/IEC 8859/1. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#ga9f7fa705b5a9329979b6f7dba5b33fef" title="Symbol representing the charset ISO/IEC 8859/1.">Mcharset_iso_8859_1</a> has name <code>"iso-8859-1"</code> and represents the charset ISO/IEC 8859-1:1998. </p>

</div>
</div>
<a class="anchor" id="ga9a9826645fbd6d8cbc8dade0a05d93ca"></a><!-- doxytag: member="charset.c::Mcharset_unicode" ref="ga9a9826645fbd6d8cbc8dade0a05d93ca" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga9a9826645fbd6d8cbc8dade0a05d93ca">Mcharset_unicode</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol representing the charset Unicode. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#ga9a9826645fbd6d8cbc8dade0a05d93ca" title="Symbol representing the charset Unicode.">Mcharset_unicode</a> has name <code>"unicode"</code> and represents the charset Unicode. </p>

</div>
</div>
<a class="anchor" id="gae9d2842894a69850db2bfba1e7003938"></a><!-- doxytag: member="charset.c::Mcharset_m17n" ref="gae9d2842894a69850db2bfba1e7003938" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gae9d2842894a69850db2bfba1e7003938">Mcharset_m17n</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol representing the largest charset. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#gae9d2842894a69850db2bfba1e7003938" title="Symbol representing the largest charset.">Mcharset_m17n</a> has name <code>"m17n"</code> and represents the charset that contains all characters supported by the m17n library. </p>

</div>
</div>
<a class="anchor" id="gaada84095266aedae3aed95ae942c47a0"></a><!-- doxytag: member="charset.c::Mcharset_binary" ref="gaada84095266aedae3aed95ae942c47a0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gaada84095266aedae3aed95ae942c47a0">Mcharset_binary</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol representing the charset for ill-decoded characters. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#gaada84095266aedae3aed95ae942c47a0" title="Symbol representing the charset for ill-decoded characters.">Mcharset_binary</a> has name <code>"binary"</code> and represents the fake charset which the decoding functions put to an M-text as a text property when they encounter an invalid byte (sequence).</p>
<p>See <a class="el" href="group__m17nConv.html">Code Conversion</a> for more details. </p>

</div>
</div>
<a class="anchor" id="gae4f12e8c6f7383fc7c05388185ad7795"></a><!-- doxytag: member="charset.c::Mmethod" ref="gae4f12e8c6f7383fc7c05388185ad7795" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gae4f12e8c6f7383fc7c05388185ad7795">Mmethod</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga26a7745dfcd4b7e75ba08b006a94205b"></a><!-- doxytag: member="charset.c::Mdimension" ref="ga26a7745dfcd4b7e75ba08b006a94205b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga26a7745dfcd4b7e75ba08b006a94205b">Mdimension</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga290793cbf5b9e6aa96cce8e12e01af29"></a><!-- doxytag: member="charset.c::Mmin_range" ref="ga290793cbf5b9e6aa96cce8e12e01af29" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga290793cbf5b9e6aa96cce8e12e01af29">Mmin_range</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gad01176e5eeb7ee45fc3b144aa0393ccd"></a><!-- doxytag: member="charset.c::Mmax_range" ref="gad01176e5eeb7ee45fc3b144aa0393ccd" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gad01176e5eeb7ee45fc3b144aa0393ccd">Mmax_range</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga002a4010b574d5b09e33281634c2b058"></a><!-- doxytag: member="charset.c::Mmin_code" ref="ga002a4010b574d5b09e33281634c2b058" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga002a4010b574d5b09e33281634c2b058">Mmin_code</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga71d715404e85831b2be9c1bb4044d1c7"></a><!-- doxytag: member="charset.c::Mmax_code" ref="ga71d715404e85831b2be9c1bb4044d1c7" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga71d715404e85831b2be9c1bb4044d1c7">Mmax_code</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga7c88134db9c464946410a44ae32969c5"></a><!-- doxytag: member="charset.c::Mascii_compatible" ref="ga7c88134db9c464946410a44ae32969c5" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga7c88134db9c464946410a44ae32969c5">Mascii_compatible</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga6fe1a313c304442d884f1dcefad262f0"></a><!-- doxytag: member="charset.c::Mfinal_byte" ref="ga6fe1a313c304442d884f1dcefad262f0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga6fe1a313c304442d884f1dcefad262f0">Mfinal_byte</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gaa971af170d28beb8e9ffca53e03f2233"></a><!-- doxytag: member="charset.c::Mrevision" ref="gaa971af170d28beb8e9ffca53e03f2233" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gaa971af170d28beb8e9ffca53e03f2233">Mrevision</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gac519cab6fd5381b289b54f9bc3f5614f"></a><!-- doxytag: member="charset.c::Mmin_char" ref="gac519cab6fd5381b289b54f9bc3f5614f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gac519cab6fd5381b289b54f9bc3f5614f">Mmin_char</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gac7f334207f0907557e1805f327be2c0a"></a><!-- doxytag: member="charset.c::Mmapfile" ref="gac7f334207f0907557e1805f327be2c0a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gac7f334207f0907557e1805f327be2c0a">Mmapfile</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gab8f3c2a0d58caa179931151fa64e5eb0"></a><!-- doxytag: member="charset.c::Mparents" ref="gab8f3c2a0d58caa179931151fa64e5eb0" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gab8f3c2a0d58caa179931151fa64e5eb0">Mparents</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gafcc44fe2009682c71b47f6157f07b85c"></a><!-- doxytag: member="charset.c::Msubset_offset" ref="gafcc44fe2009682c71b47f6157f07b85c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gafcc44fe2009682c71b47f6157f07b85c">Msubset_offset</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="gad98a8b772b9e851ae2920c5d7ed7c706"></a><!-- doxytag: member="charset.c::Mdefine_coding" ref="gad98a8b772b9e851ae2920c5d7ed7c706" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gad98a8b772b9e851ae2920c5d7ed7c706">Mdefine_coding</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga150e01319257d2b8e82952baf4fbb16d"></a><!-- doxytag: member="charset.c::Maliases" ref="ga150e01319257d2b8e82952baf4fbb16d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga150e01319257d2b8e82952baf4fbb16d">Maliases</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

</div>
</div>
<a class="anchor" id="ga7a86139a02caa1fba4cc46985b76c71b"></a><!-- doxytag: member="charset.c::Moffset" ref="ga7a86139a02caa1fba4cc46985b76c71b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga7a86139a02caa1fba4cc46985b76c71b">Moffset</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for the offset type method of charset. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#ga7a86139a02caa1fba4cc46985b76c71b" title="Symbol for the offset type method of charset.">Moffset</a> has the name <code>"offset"</code> and, when used as a value of <b>Mmethod</b> parameter of a charset, it means that the conversion of code-points and character codes of the charset is done by this calculation:</p>
<div class="fragment"><pre class="fragment">
CHARACTER-CODE = CODE-POINT - MIN-CODE + MIN-CHAR
</pre></div><p>where, MIN-CODE is a value of <b>Mmin_code</b> parameter of the charset, and MIN-CHAR is a value of <b>Mmin_char</b> parameter. </p>

</div>
</div>
<a class="anchor" id="gaa774b1759de6142d26ffe8d5898c3874"></a><!-- doxytag: member="charset.c::Mmap" ref="gaa774b1759de6142d26ffe8d5898c3874" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gaa774b1759de6142d26ffe8d5898c3874">Mmap</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for the map type method of charset. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#gaa774b1759de6142d26ffe8d5898c3874" title="Symbol for the map type method of charset.">Mmap</a> has the name <code>"map"</code> and, when used as a value of <b>Mmethod</b> parameter of a charset, it means that the conversion of code-points and character codes of the charset is done by map looking up. The map must be given by <b>Mmapfile</b> parameter. </p>

</div>
</div>
<a class="anchor" id="gadd42d3be420b71333a771b05e4e5b6eb"></a><!-- doxytag: member="charset.c::Munify" ref="gadd42d3be420b71333a771b05e4e5b6eb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gadd42d3be420b71333a771b05e4e5b6eb">Munify</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for the unify type method of charset. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#gadd42d3be420b71333a771b05e4e5b6eb" title="Symbol for the unify type method of charset.">Munify</a> has the name <code>"unify"</code> and, when used as a value of <b>Mmethod</b> parameter of a charset, it means that the conversion of code-points and character codes of the charset is done by map looking up and offsetting. The map must be given by <b>Mmapfile</b> parameter. For this kind of charset, a unique continuous character code space for all characters is assigned.</p>
<p>If the map has an entry for a code-point, the conversion is done by looking up the map. Otherwise, the conversion is done by this calculation:</p>
<div class="fragment"><pre class="fragment">
CHARACTER-CODE = CODE-POINT - MIN-CODE + LOWEST-CHAR-CODE
</pre></div><p>where, MIN-CODE is a value of <b>Mmin_code</b> parameter of the charset, and LOWEST-CHAR-CODE is the lowest character code of the assigned code space. </p>

</div>
</div>
<a class="anchor" id="gaf9a6baf718f22984b5c5332afff0da90"></a><!-- doxytag: member="charset.c::Msubset" ref="gaf9a6baf718f22984b5c5332afff0da90" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gaf9a6baf718f22984b5c5332afff0da90">Msubset</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for the subset type method of charset. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#gaf9a6baf718f22984b5c5332afff0da90" title="Symbol for the subset type method of charset.">Msubset</a> has the name <code>"subset"</code> and, when used as a value of <b>Mmethod</b> parameter of a charset, it means that the charset is a subset of a parent charset. The parent charset must be given by <b>Mparents</b> parameter. The conversion of code-points and character codes of the charset is done conceptually by this calculation:</p>
<div class="fragment"><pre class="fragment">
CHARACTER-CODE = PARENT-CODE (CODE-POINT) + SUBSET-OFFSET
</pre></div><p>where, PARENT-CODE is a pseudo function that returns a character code of CODE-POINT in the parent charset, and SUBSET-OFFSET is a value given by <b>Msubset_offset</b> parameter. </p>

</div>
</div>
<a class="anchor" id="gadb08660f5913095d985cfbbd1a51b0bb"></a><!-- doxytag: member="charset.c::Msuperset" ref="gadb08660f5913095d985cfbbd1a51b0bb" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#gadb08660f5913095d985cfbbd1a51b0bb">Msuperset</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Symbol for the superset type method of charset. </p>
<p>The symbol <a class="el" href="group__m17nCharset.html#gadb08660f5913095d985cfbbd1a51b0bb" title="Symbol for the superset type method of charset.">Msuperset</a> has the name <code>"superset"</code> and, when used as a value of <b>Mmethod</b> parameter of a charset, it means that the charset is a superset of parent charsets. The parent charsets must be given by <b>Mparents</b> parameter. </p>

</div>
</div>
<a class="anchor" id="ga45426542709f174689a06ce7c34a37de"></a><!-- doxytag: member="database.c::Mcharset" ref="ga45426542709f174689a06ce7c34a37de" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> <a class="el" href="group__m17nCharset.html#ga45426542709f174689a06ce7c34a37de">Mcharset</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The symbol <code>Mcharset</code>. </p>
<p>Any decoded M-text has a text property whose key is the predefined symbol <code>Mcharset</code>. The name of <code>Mcharset</code> is <code>"charset"</code>. </p>

</div>
</div>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
